const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const affiliate_programs = sequelize.define(
    'affiliate_programs',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

program_name: {
        type: DataTypes.TEXT,
      
      

      },

status: {
        type: DataTypes.ENUM,
      
      

        values: [

"draft",


"active",


"paused",


"closed"

        ],

      },

commission_rate_percent: {
        type: DataTypes.DECIMAL,
      
      

      },

terms_text: {
        type: DataTypes.TEXT,
      
      

      },

min_trust_score_to_join: {
        type: DataTypes.INTEGER,
      
      

      },

starts_at: {
        type: DataTypes.DATE,
      
      

      },

ends_at: {
        type: DataTypes.DATE,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  affiliate_programs.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity



































    db.affiliate_programs.hasMany(db.affiliate_memberships, {
      as: 'affiliate_memberships_program',
      foreignKey: {
          name: 'programId',
      },
      constraints: false,
    });










//end loop



    db.affiliate_programs.belongsTo(db.stores, {
      as: 'producer_store',
      foreignKey: {
        name: 'producer_storeId',
      },
      constraints: false,
    });

    db.affiliate_programs.belongsTo(db.organizations, {
      as: 'organizations',
      foreignKey: {
        name: 'organizationsId',
      },
      constraints: false,
    });




    db.affiliate_programs.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.affiliate_programs.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return affiliate_programs;
};


